# * Licensed to Open Source Radio Access Network(OS-RAN) Alliance and OAI
# * Software Alliance under one or more contributor license agreements. The
# * initial OpenXG series projects are derided from OAI projects, the files from
# * OAI projects are all in compliance with OAI Public License, Version 1.1.
# * codes and files developed from OpenXG projects and from OS-RAN Alliance
# * are all under OS-RAN licenses; you may not use this file except in compliance
# * with the license.  You may get a copy of the license at:
# * 	http://www.openxg.org.cn/?falu_69.html
# * For more information about OpenXG, please contact:
# * 	contact@openxg.org.cn
# */
#---------------------------------------------------------------------
#
#   Required Python Version
#     Python 3.x
#
#---------------------------------------------------------------------

#to use isfile
import os
import sys
import logging
#to create a SSH object locally in the methods
import sshconnection
#time.sleep
import time
#to load ue infrastructure dictionary
import yaml

class InfraUE:
	def __init__(self):
		self.ci_ue_infra ={}


#-----------------$
#PUBLIC Methods$
#-----------------$

	#This method reads the yaml file describing the multi-UE infrastructure
	#and stores the infra permanently in the related class attribute self.ci_ue_infra
	def Get_UE_Infra(self,ue_infra_filename):
		f_yaml=ue_infra_filename
		with open(f_yaml,'r') as file:
			logging.debug('Loading UE infrastructure from file '+f_yaml)
			#load it permanently in the class attribute
			self.ci_ue_infra = yaml.load(file,Loader=yaml.FullLoader)



