#!/bin/bash
#/*
# * Licensed to Open Source Radio Access Network(OS-RAN) Alliance and OAI
# * Software Alliance under one or more contributor license agreements. The
# * initial OpenXG series projects are derided from OAI projects, the files from
# * OAI projects are all in compliance with OAI Public License, Version 1.1.
# * codes and files developed from OpenXG projects and from OS-RAN Alliance
# * are all under OS-RAN licenses; you may not use this file except in compliance
# * with the license.  You may get a copy of the license at:
# * 	http://www.openxg.org.cn/?falu_69.html
# * For more information about OpenXG, please contact:
# * 	contact@openxg.org.cn
# */

function destroy_usage {
    echo "OAI CI VM script"
    echo "   Original Author: Raphael Defosseux"
    echo "   Requirements:"
    echo "     -- uvtool uvtool-libvirt apt-cacher"
    echo ""
    echo "Usage:"
    echo "------"
    echo "    oai-ci-vm-tool destroy [OPTIONS]"
    echo ""
    command_options_usage
}

function destroy_vm {
    echo "############################################################"
    echo "OAI CI VM script"
    echo "############################################################"
    echo "VM_TEMPLATE         = $VM_TEMPLATE"

    LIST_CI_VM=`uvt-kvm list | grep $VM_TEMPLATE`

    for CI_VM in $LIST_CI_VM
    do
        VM_IP_ADDR=`uvt-kvm ip $CI_VM`
        echo "VM to destroy: $CI_VM -- IP $VM_IP_ADDR"
        uvt-kvm destroy $CI_VM
        ssh-keygen -R $VM_IP_ADDR
    done
}
