#/*
# * Licensed to Open Source Radio Access Network(OS-RAN) Alliance and OAI
# * Software Alliance under one or more contributor license agreements. The
# * initial OpenXG series projects are derided from OAI projects, the files from
# * OAI projects are all in compliance with OAI Public License, Version 1.1.
# * codes and files developed from OpenXG projects and from OS-RAN Alliance
# * are all under OS-RAN licenses; you may not use this file except in compliance
# * with the license.  You may get a copy of the license at:
# * 	http://www.openxg.org.cn/?falu_69.html
# * For more information about OpenXG, please contact:
# * 	contact@openxg.org.cn
# */
#---------------------------------------------------------------------
# Python for CI of OAI-eNB + COTS-UE
#
#   Required Python Version
#     Python 3.x
#
#   Required Python Package
#     pexpect
#---------------------------------------------------------------------


#-----------------------------------------------------------
# Import Libs
#-----------------------------------------------------------
import sys		# arg
import re		# reg
import os
import subprocess


class SplitReport():
	def __init__(self):
		self.logfilename = ''
		self.destinationFolder = ''

	def split(self):
		self.destinationFolder = self.logfilename.replace(".log","")
		if os.path.isfile(self.logfilename):
			newImageLog = open(self.logfilename + '.new', 'w')
			copyFlag = True
			with open(self.logfilename, 'r') as imageLog:
				for line in imageLog:
					header = False
					ret = re.search('====== Start of log for ([0-9\.A-Za-z\-\_]+) ======', line)
					if ret is not None:
						copyFlag = False
						header = True
						detailedLogFile = open(self.destinationFolder + '/' + ret.group(1), 'w')
					if copyFlag:
						newImageLog.write(line)
					ret = re.search('====== End of log for ([0-9\.A-Za-z\-\_]+) ======', line)
					if ret is not None:
						copyFlag = True
						detailedLogFile.close()
					elif not copyFlag and not header:
						detailedLogFile.write(line)
			imageLog.close()
			newImageLog.close()
			os.rename(self.logfilename + '.new', self.logfilename)
		else:
			print('Cannot split unfound file')

#--------------------------------------------------------------------------------------------------------
#
# Start of main
#
#--------------------------------------------------------------------------------------------------------

argvs = sys.argv
argc = len(argvs)

SP = SplitReport()

while len(argvs) > 1:
	myArgv = argvs.pop(1)
	if re.match('^\-\-logfilename=(.+)$', myArgv, re.IGNORECASE):
		matchReg = re.match('^\-\-logfilename=(.+)$', myArgv, re.IGNORECASE)
		SP.logfilename = matchReg.group(1)

SP.split()

sys.exit(0)
